=== src/CMakeLists.txt ===
add_subdirectory(gtirb_layout)
add_subdirectory(gtirb_pprinter)
