=== tests/requirements.txt ===
# Requirements for running tests. These should be kept minimal because the
# conanfile runs tests by default.
gtirb
gtirb-test-helpers
